<?php
include('/usr/fallback/beroConf.php');
include('/usr/local/php/include/fulltrace.Class.php');

/**
 * Klasse Fulltrace
 */
?>
<script type="text/javascript" src="misc/script/fulltrace.js"></script>


<?php
class FulltraceGui {

	private $_ba;
	private $_bc;
	private $_ft;

	function __construct () {
		$this->_ba = new beroAri();
		$this->_bc = new beroConf('root');
		$this->_ft = new fulltrace();
	}

	// Die Funktion ports wird benutzt um alle ISDN Ports anzuzeigen.
	function show_isdn_ports () {
		$qu = $this->_ba->select('SELECT * FROM isdn');
		while ($entry = $this->_ba->fetch_array($qu)) {
			// Für jeden Port wird ein checkbox erzeugt
			$select .= '<input type="checkbox" name="ports[]" value="' . $entry['port'] . '" checked /><label for="ports[]">' . $entry['port'] . "</label>\n";
		}

		return($select);
	}

	private function _show_trace_run () {

		$ret =	'<br /><form method="POST">' .
			'<table class="table table-striped table-bordered" style="max-width: 520px; margin:auto;">' .
			'<tr><th colspan="2">' . FULL_TRACE_TABLE_HEADER_DIS . '</th></tr>' .
			'<tr><td><img src="includes/images/punkt_gruen.gif" /></td>' .
			'<td>' .
			'<input type="submit" class="btn btn-default" id="trace" name="trace" onmouseover="Tip(\'' . DEBUG_STOP_TRACE . '\')" onmouseout="UnTip()" value="Stop" />' .
			'</td></tr>' .
			'</table> ' .
			'</form><br />';

		// we don't display file-download during trace if we're not 'advanced'
		if (((strlen($this->_ba->get('gui_mode')) == 0) ? 'easy' : $this->_ba->get('gui_mode')) != 'advanced') {
			return($ret);
		}

		$ret .= '<table class="table table-striped table-bordered" style="max-width: 520px; margin:auto;">' .
			'<tr><th colspan="2">Single File Download</th></tr>';

		foreach ($this->_ft->get_runtime_files() as $ftFile) {
			if (empty($ftFile)) {
				continue;
			}
			$ret .= '<tr><td>' . basename($ftFile) . '</td>' .
				'<td>' .
				'<form name="download_logfile" action="modules/FulltraceGui/isdn_trace.php?option=single_logfile" method="POST">' .
				'<input type="hidden" name="logfile_name" value="' . basename($ftFile) . '" />' .
				'<input type="submit" class="btn btn-default" value="Download" />' .
				'</form>' .
				'</td></tr>';
		}
		$ret .= '</table>'
			. '<br />';

		return($ret);
	}

	function table() {

		$colspan = 2;
		unset($th);
		unset($td);

		
		$mode ='<input type="radio" name="fulltrace_type" id="fulltrace_type" onclick="hide_fulltrace_advanced(0);"  value="0" checked> Basic<br>';
		$mode .='<input type="radio"  name="fulltrace_type" id="fulltrace_type" onclick="hide_fulltrace_advanced(1);" value="1"> Advanced <br>';
		

		$table_td = '';

		$advanced_options="<input type='text' class='form-control id='ft_advanced_options' name='ft_advanced_options'>";

		$html_str .=	"<br/><form method='POST'>
				<table class='table table-striped table-bordered' id='table' style='max-width:520px; margin:auto; text-align: center;'>
				<tr><th colspan='$colspan' class='text-center'>" . FULL_TRACE_TABLE_HEADER_DIS . "</th></tr>
                                <tr>
                                $table_td_title$th
                                </tr>
                                <tr>
                                $table_td
                                <td>
                                $mode
                                <div id='advanced_fulltrace_settings'>
				<fieldset>
				<br/>
				Optional Fulltrace Parameters
				$advanced_options
				</fieldset>
				</div>
				</td>
				$td
				</tr>
				<tr>
				<td colspan='$colspan' class='text-center'>
				<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;
				<input type='submit' class='btn btn-default' id='trace' name='trace' onmouseover=\"Tip('" . DEBUG_START_TRACE . "')\" onmouseout='UnTip()' value='" . FULL_TRACE_BUTTON_START_DIS . "'>
				</td>
				</tr>
				</table>
				</form><br/>";

		return $html_str;
	}

	function display() {

		$name = 'FULL_TRACE_TITLE_DIS';
		include('./includes/header.php');
		require_once('./includes/isgwtelnet.php');

		// actually js belongs into a separate file...
			$ret .=	'<script language="javascript">' . "\n" .
			'function checkallp () {' . "\n" .
			'var checkall = document.getElementById(\'checkall\');' . "\n" .
			'var del = document.getElementsByName(\'ports[]\');' . "\n" .
			'if (checkall.checked == true) {' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].checked=true;' . "\n" .
			'}' . "\n" .
			'} else {' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].checked = false;' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'}' . "\n\n" .
			'function dis() {' . "\n" .
			'var isdn_enable = document.getElementById(\'isdn_enable\');' . "\n" .
			'var checkall = document.getElementById(\'checkall\');' . "\n" .
			'var del = document.getElementsByName(\'ports[]\');' . "\n" .
			'if (isdn_enable.checked == true) {' . "\n" .
			'checkall.disabled = false;' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].disabled = false;' . "\n" .
			'}' . "\n" .
			'} else {' . "\n" .
			'checkall.disabled = true;' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].disabled = true;' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'</script>';

		switch ($_POST['trace']) {
		case 'Start':
			$enable['fulltrace_type'] =(($_POST['fulltrace_type'] == '1') ? 1 : 0);

			$log_size = (($this->_bc->get('root', 'cifs_log_enabled') == '1') ? $this->_bc->get('root', 'cifs_log_size') : null);
			$this->_ft->start($enable, $_POST['ports'], $log_size, $_POST['ft_advanced_options']);
			unset($enable);
			$ret .= $this->_show_trace_run();
			break;
		case 'Stop':
			$log_date = (($this->_bc->get('root', 'cifs_log_enabled') == '1') ? true : false);
			$this->_ft->stop($log_date);
			$ret .= $this->table();
			break;
		default:
			if ($this->_ba->get('trace') == 'yes') {
				$ret .= $this->_show_trace_run();
				break;
			}
			$ret .= $this->table();
			break;
		}
/*
		if (((strlen($this->_ba->get('trace')) == 0) || ($this->_ba->get('trace') == 'no')) && !isset($_POST['trace'])) {
			$ret .= $this->table();
		} elseif ($_POST['trace'] == 'Start' ) {

		} else if ($_POST['trace'] == 'Stop') {
		} else if ($this->_ba->get('trace') == 'yes') {
			$ret .= $this->_show_trace_run();
		}
 */
	/*
	 * Überprüfung ob die dateien debug-info.tar.gz oder DebugFiles.tar.gz oder isgw.err,
	 * Wenn ja, wird einen Link für Download angeboten, und einen Link delete
	 * um die entsprechende Datei zu löschen
	 */
	if (file_exists("/var/log/debug-info.tar.gz") || file_exists("/var/log/DebugFiles.tar.gz") || file_exists("/var/log/isgw.err")){
		$ret.="<form method='POST'>
			<table class='table table-striped table-bordered' style='max-width:520px; margin:auto;'>
				<tr><th colspan='2'>".FULL_TRACE_DOWNLOADS_DIS."</th></tr>";
		if (file_exists("/var/log/debug-info.tar.gz"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_ISGW_COREDUMPS_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php?option=isgw';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DELETE_FILE_DIS."' onclick=\"javascript:if (confirm('".FULL_TRACE_DELETE_COREDUMPS_DIS."?')==true) window.location.href='misc/deletefile.php?m=".$_GET['m']."';\" onmouseover=\"Tip('".DEBUG_DELETE."')\" onmouseout='UnTip()'></td>
			<td>".date("d M Y H:i",filectime("/var/log/debug-info.tar.gz"))."</td>
			</tr>";
		if (file_exists("/var/log/DebugFiles.tar.gz"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_DEBUG_FILES_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DELETE_FILE_DIS."' onclick=\"javascript:if (confirm('".FULL_TRACE_DELETE_DEBUG_FILES_DIS."?')==true) window.location.href='misc/deletefile.php?m=".$_GET['m']."&option=debug';\" onmouseover=\"Tip('".DEBUG_DELETE_FILES."')\" onmouseout='UnTip()'>
			<td>".date("d M Y H:i",filectime("/var/log/DebugFiles.tar.gz"))."</td>
			</tr>";
		if (file_exists("/var/log/isgw.err"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_ERROR_LOG_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php?option=error';\" >&nbsp;&nbsp;
			<td>".date("d M Y H:i",filectime("/var/log/isgw.err"))."</td>
			</tr>";
		if (file_exists("/var/log/cloud.log"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_CLOUD_LOG_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php?option=cloud';\" >&nbsp;&nbsp;
			<td>".date("d M Y H:i",filectime("/var/log/cloud.log"))."</td>
			</tr>";
		$ret.="</table>"
			. "</form><br/>";
	}


	//Rückgabe: Der Inhalt von der HTML-Seite
	return $ret;
}
}
?>
